/**
 * Pixelate  
 * by Hernando Barragan. 
 * 
 * Load a QuickTime file and display the video signal 
 * using rectangles as pixels by reading the values stored 
 * in the current video frame pixels array. 
 *
 *
 * Modified by Patrick Müller.
 * 
 * Load Flash Films
 * Capture Frames and save as Image by clicking anywhere.
 *
 **/

import codeanticode.gsvideo.*;

int numPixels;
int blockSize = 20;
GSMovie myMovie;
color myMovieColors[];

void setup() {
  
  size(840, 480, P2D);
  frameRate(20);
    
  noStroke();
  background(0);
  
  myMovie = new GSMovie(this, "videoplayback.flv");
  myMovie.loop();
  numPixels = width / blockSize;
  myMovieColors = new color[numPixels * numPixels];
  
}

// Read new values from movie
void movieEvent(GSMovie m) {
  m.read();
  m.loadPixels();
  
  for (int j = 0; j < numPixels; j++) {
    for (int i = 0; i < numPixels; i++) {
      myMovieColors[j * numPixels + i] = m.get(i*blockSize, j*blockSize);
    }
  }
}


// Display values from movie
void draw()  {
  for (int j = 0; j < numPixels; j++) {
    for (int i = 0; i < numPixels; i++) {
      fill(myMovieColors[j*numPixels + i]);
      rect(i*blockSize, j*blockSize, blockSize-1, blockSize-1);
    }
  }
}

// Capture Screen
void mousePressed() {
  saveFrame("SCREEN-####.PNG");
  println("IMAGE SAVED!");
}
